// Geant4 Libraries
//


// Local Libraries
//
#include "ActionInitialization.hh"
#include "PrimaryGeneratorAction.hh"
#include "RunAction.hh"
#include "SteppingAction.hh"
#include "SteppingVerbose.hh"
#include "EventAction.hh"


//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

ActionInitialization::ActionInitialization()
 : G4VUserActionInitialization()
{
   G4cout << "...ActionInitialization..." << G4endl;
   parCrk = new PrimarySpectrum();
}

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

ActionInitialization::~ActionInitialization()
{}

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

void ActionInitialization::BuildForMaster() const
{
  RunAction* runAction = new RunAction;
  SetUserAction(runAction);
}

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

void ActionInitialization::Build() const
{
  RunAction* runAction = new RunAction();
  SetUserAction(runAction);

  PrimaryGeneratorAction* primaryGenAction = new PrimaryGeneratorAction(parCrk);
  SetUserAction(primaryGenAction);

  EventAction* eventAction = new EventAction(runAction, primaryGenAction);
  SetUserAction(eventAction);

  SteppingAction* stepAction = new SteppingAction(eventAction);
  SetUserAction(stepAction);
}

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

G4VSteppingVerbose* ActionInitialization::InitializeSteppingVerbose() const
{
  return new SteppingVerbose();
}  

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
